#!/bin/bash

# Check for expat library
EXPATLIB=libexpat.a
if [ -f /lib/$EXPATLIB ]; then
  found=1
elif [ -f /usr/lib/$EXPATLIB ]; then
  found=1
elif [ -f /usr/local/lib/$EXPATLIB ]; then
  found=1
else
	echo "Expat library not found, please install: http://sourceforge.net/projects/expat"
	exit
fi

# USE THE CORRECT PERL BINARY AND TMP DIRS
PATH=$PWD/PerlSrc/perl/bin:$PATH
export PATH
TEMPDIR=$PWD/tmp
TMP=$PWD/tmp
export TMP
export TEMPDIR
/bin/rm -rf tmp > /dev/null >& /dev/null
mkdir tmp

PERLBIN=$PWD/PerlSrc/perl/bin

# UNPACK AND BUILD REQUIRED MODULES
/bin/rm -rf PerlModules
mkdir PerlModules
cd PerlModules

# ... FOR PAR
for ff in `cat ../par-deps.list`; do
	f=`echo $ff | sed -e 's/::/-/g'`
	tar zxvf ../Tars/$f-[0-9]*.tar.gz
	cd $f-[0-9]*
	if [ -f Makefile ] ; then
		make clean
		/bin/rm Makefile.old
	fi
	perl Makefile.PL
	make
	make test
	sleep 2
	make install
	cd ..
done

# Build PAR
tar zxvf ../Tars/PAR-[0-9]*.tar.gz
cd PAR-[0-9]*
if [ -f Makefile ] ; then
	make clean
	/bin/rm Makefile.old
fi
perl Makefile.PL
make
make test
sleep 2
make install
cd ..

# ... FOR VCP
for ff in `cat ../vcp-deps.list`; do
	f=`echo $ff | sed -e 's/::/-/g'`
	tar zxvf ../Tars/$f-*.tar.gz
	cd $f-[0-9]*
	if [ -f Makefile ] ; then
		make clean
		/bin/rm Makefile.old
	fi
	perl Makefile.PL
	if [ "$f" == "PodToHTML" ]; then
		# Patch the HTML_Elements.pm file
		patch -R Pod/HTML_Elements.pm ../../PodToHTML.Pod.HTML_Elements.pm.patch
	fi
	make
	make test
	sleep 2
	make install
	cd ..
done
