#!/bin/bash

# BUILD PERL
PATH=$PWD/PerlSrc/perl/bin:$PATH
export PATH
TEMPDIR=$PWD/tmp
TMP=$PWD/tmp
export TMP
export TEMPDIR

PERLBIN=$PWD/PerlSrc/perl/bin/perl

# BUILD VCP
if [ -d PerlModules/VCP-[0-9]* ] ; then
	if [ -d dist ] ; then
		echo "Building into $PWD/dist"
	else
		mkdir dist
		echo "Building into $PWD/dist"
	fi
	cd PerlModules
	version=`ls -d VCP-[0-9]* | sed -e 's/VCP/vcp/'`
	cd VCP-[0-9]*
else
	echo "PerlModule/VCP-... is not installed, please create"
	echo "Run: (cd PerlModules; tar zxvf ../VCP-*.tar.gz)"
	exit
fi
perl Makefile.PL
make
for f in bin/* t/*; do 
	sed -e "s=#!/usr/local/bin/perl=#!$PERLBIN=" $f > $f.$$
	/bin/mv -f $f.$$ $f
done

# Save dist version of vcp and remove module list code which breaks tests
cp bin/vcp bin/vcp.dist
patch bin/vcp ../../vcp.bin.vcp.patch
make test
make install

# BUILD HTML TREE
make vcp_html/index.html

# BUILD EXE VCP
# Restore dist version
/bin/mv -f bin/vcp.dist bin/vcp
# drop the -lib=lib so that it uses the installed version
patch bin/build_vcp_executable.pl ../../vcp.bin.build_vcp_executable.pl.patch
$PERLBIN bin/build_vcp_executable.pl

# TEST EXE
#   ***TBD***

kername=`uname -r`
/bin/rm -f ../../dist/$version-$kername.exe
/bin/cp $PWD/vcp-bin ../../dist/$version-$kername.exe
gzip ../../dist/$version-$kername.exe
/bin/rm -rf ../../dist/html ../../dist/vcp_html
tar cf - vcp_html | (cd ../../dist ; tar xf - )
/bin/mv ../../dist/vcp_html ../../dist/html

echo "VCP Binary: $version-$kername.exe.gz"

