#!/bin/bash

# Retrieve current stable perl
if [ -d Tars ]; then
	cd Tars
else
	mkdir Tars
	cd Tars
fi

# CURRENT PERL SOURCE
echo "http://www.cpan.org/src/stable.tar.gz" > modules.$$

# Retrieve list of current modules
wget -N http://www.cpan.org/modules/02packages.details.txt.gz
/bin/rm perl-modules.txt.gz perl-modules.txt > /dev/null >& /dev/null
cp 02packages.details.txt.gz perl-modules.txt.gz
gunzip perl-modules.txt.gz

# PAR REQUIRED MODULES
for f in `cat ../par-deps.list`; do
	egrep -m 1 --regexp="^$f " perl-modules.txt | awk '{ printf "http://search.cpan.org/CPAN/authors/id/%s\n", $3; }' >> modules.$$
done


# ADD PAR
# PAR 0.83 is broken, use 0.82
egrep -m 1 --regexp="^PAR " perl-modules.txt | awk '{ printf "http://search.cpan.org/CPAN/authors/id/%s\n", $3; }' | sed -e 's/83/82/' >> modules.$$

# VCP REQUIRED MODULES
for f in `cat ../vcp-deps.list`; do
	# Pod:HTML_Elements and PoD:Links are in PodToHTML package
	if [ "$f" == "PodToHTML" ] ; then
		f="Pod::HTML_Elements"
	# HTML::FormatPS is in HTML::Format package
	elif [ "$f" == "HTML::Format" ] ; then
		f="HTML::FormatPS"
	# IO::File is in IO package
	elif [ "$f" == "IO" ] ; then
		f="IO::File"
	fi
	egrep -m 1 --regexp="^$f " perl-modules.txt | awk '{ printf "http://search.cpan.org/CPAN/authors/id/%s\n", $3; }' >> modules.$$
done

/bin/rm perl-modules.txt.gz perl-modules.txt > /dev/null >& /dev/null
sort modules.$$ > modules.list
/bin/rm modules.$$
echo "modules.list generated, run '(cd Tars; wget -N -i modules.list)' to retrieve modules"
